<template>
<v-autocomplete
          v-model="product"
          :loading="loading"
          :items="product_options"
          :search-input.sync="search"
          class="search_pad flex-full-width"
          hide-details
          item-text="name"
          item-value="id"
          label="Search product"
          rounded
          menu-icon=""
          append-inner-icon="mdi-magnify"
          prepend-inner-icon="mdi-magnify"
          
        >

        <template v-slot:no-data>
            <span class="no_search_product" v-if="!search">Please enter a keyword.</span>
            <span class="no_search_product" v-else>No Results Found</span>
        </template>
        <template v-slot:item="{ item }">
          
            <a class="search_result_text" :href="buildProductUrl(item)"  replace>
          <v-row :class="(item.name!=null && item.name.toLowerCase().includes(search.toLowerCase())) ? 'active' : ''">
            <v-col cols="3" md="3">
              <a class="search_result_text" :href="buildProductUrl(item)"  replace>
                <img v-if="item.file_upload.length>0" :src="options.storage_root+'/'+item.file_upload[0].upload.uploaded_path" :title="(item.file_upload[0].title
!=null) ? item.file_upload[0].title : item.name" :alt="(item.file_upload[0].alt_text!=null) ? item.file_upload[0].alt_text : item.name"/>
                <img src="/images/no-img.png" v-else  title="" alt="" />
              </a>
            </v-col>
            <v-col cols="9">
              <a class="search_result_text" :href="buildProductUrl(item)"  replace>{{item.name}}</a>
            </v-col>
          </v-row>
            </a>
        </template>
        </v-autocomplete>
</template>
<script>
import options from '~/assets/options';
export default {
  data() {
      return {
        options             : options,
          search            : "",
          product_options   : [],
          loading           : false,
          product           : null,
          location_name     : this.$store.state.front_end_data.location_name
      }
  },
  mounted() {
},
watch: {
    search(val) {
        if(val!=null && val.length>0) {
            this.getProducts();
        }
        else {
            this.product_options = [];
        }
        
    }
},
  methods: {
    buildProductUrl(product) {
        let location_name = (this.location_name!=null && this.location_name!='') ? '/'+this.location_name+'/' : '/';
        let parent_category = (product.default_category.parent_category!=null) ? product.default_category.parent_category.link_rewrite+'/' : "";
        let route = location_name+parent_category+product.default_category.link_rewrite+'/'+product.link_rewrite;
        return route;
      },
      getProducts() {
          this.product_options = [];
          let current_host = this.$store.state.front_end_data.domain_id;
          let location = this.$store.state.front_end_data.location;
          this.product = null;
          if(this.search!="" && this.search!=null) {
             this.$axios.$get(`/api/search-product/${this.search}/${current_host}/${location}`)
              .then(resp=>{
                this.product_options = resp;
              });
          }
          else {
            this.product_options = [];
          }
          setTimeout(()=>{
              if(this.search==null||this.search=="") {
                  this.product_options = [];
                  this.search = null;
              }
          },1000)
      }
  }
}
</script>